# wxCursor Class Reference
[Graphics Device Interface (GDI)]

`#include <wx/cursor.h>`

Inheritance diagram for wxCursor:
[legend]

## Detailed Description

A cursor is a small bitmap usually used for denoting where the mouse pointer is, with a picture that might indicate the interpretation of a mouse click.

As with icons, cursors in X and MS Windows are created in a different manner. Therefore, separate cursors will be created for the different environments. Platform-specific methods for creating a wxCursor object are catered for, and this is an occasion where conditional compilation will probably be required (see wxIcon for an example).

A single cursor object may be used in many windows (any subwindow type). The wxWidgets convention is to set the cursor for a window, as in X, rather than to set it globally as in MS Windows, although a global wxSetCursor() function is also available for MS Windows use.

## Creating a Custom Cursor

The following is an example of creating a cursor from 32x32 bitmap data (down_bits) and a mask (down_mask) where 1 is black and 0 is white for the bits, and 1 is opaque and 0 is transparent for the mask. It works on Windows and GTK+.

        static char down_bits[] = { 255, 255, 255, 255, 31,
            255, 255, 255, 31, 255, 255, 255, 31, 255, 255, 255,
            31, 255, 255, 255, 31, 255, 255, 255, 31, 255, 255,
            255, 31, 255, 255, 255, 31, 255, 255, 255, 25, 243,
            255, 255, 19, 249, 255, 255, 7, 252, 255, 255, 15, 254,
            255, 255, 31, 255, 255, 255, 191, 255, 255, 255, 255,
            255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
            255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
            255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
            255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
            255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
            255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
            255 };

        static char down_mask[] = { 240, 1, 0, 0, 240, 1,
            0, 0, 240, 1, 0, 0, 240, 1, 0, 0, 240, 1, 0, 0, 240, 1,
            0, 0, 240, 1, 0, 0, 240, 1, 0, 0, 255, 31, 0, 0, 255,
            31, 0, 0, 254, 15, 0, 0, 252, 7, 0, 0, 248, 3, 0, 0,
            240, 1, 0, 0, 224, 0, 0, 0, 64, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
            0, 0, 0, 0, 0 };

        #ifdef __WXMSW__
            wxBitmap down_bitmap(down_bits, 32, 32);
            wxBitmap down_mask_bitmap(down_mask, 32, 32);

            down_bitmap.SetMask(new wxMask(down_mask_bitmap));
            wxImage down_image = down_bitmap.ConvertToImage();
            down_image.SetOption(wxIMAGE_OPTION_CUR_HOTSPOT_X, 6);
            down_image.SetOption(wxIMAGE_OPTION_CUR_HOTSPOT_Y, 14);
            wxCursor down_cursor = wxCursor(down_image);
        #elif defined(__WXGTK__) or defined(__WXMOTIF__)
            wxCursor down_cursor = wxCursor(down_bits, 32, 32, 6, 14,
                                            down_mask, wxWHITE, wxBLACK);
        #endif

##

Library: wxCore

Category: Graphics Device Interface (GDI)

Predefined objects/pointers:

- wxNullCursor
- wxSTANDARD_CURSOR
- wxHOURGLASS_CURSOR
- wxCROSS_CURSOR

See also:
  wxBitmap, wxIcon, wxWindow::SetCursor(), wxSetCursor(), wxStockCursor

## Public Member Functions
| wxCursor ()
| Default constructor.
| wxCursor (const char bits[], int width, int height, int hotSpotX=-1, int hotSpotY=-1, const char maskBits[]=NULL)
| Constructs a cursor by passing an array of bits (XBM data).
| wxCursor (const wxString &cursorName, wxBitmapType type=wxCURSOR_DEFAULT_TYPE, int hotSpotX=0, int hotSpotY=0)
| Constructs a cursor by passing a string resource name or filename.
| wxCursor (wxStockCursor cursorId)
| Constructs a cursor using a cursor identifier.
| wxCursor (const wxImage &image)
| Constructs a cursor from a wxImage.
| wxCursor (const wxCursor &cursor)
| Copy constructor, uses reference counting.
virtual | ~wxCursor ()
| Destroys the cursor.
virtual bool | IsOk () const
| Returns true if cursor data is present.
wxCursor & | operator= (const wxCursor &cursor)
| Assignment operator, using reference counting.

List of all members.

## Constructor & Destructor Documentation

wxCursor::wxCursor | ( |  | ) |

Default constructor.

wxCursor::wxCursor | ( | const char | bits[],
|  | int | width,
|  | int | height,
|  | int | hotSpotX = `-1`,
|  | int | hotSpotY = `-1`,
|  | const char | maskBits[] = `NULL` |
| ) |  |  |

Constructs a cursor by passing an array of bits (XBM data).

The parameters fg and bg have an effect only on GTK+, and force the cursor to use particular background and foreground colours.

If either hotSpotX or hotSpotY is -1, the hotspot will be the centre of the cursor image (Motif only).

Parameters:

  | bits | An array of XBM data bits.
  | width | Cursor width.
  | height | Cursor height.
  | hotSpotX | Hotspot x coordinate (relative to the top left of the image).
  | hotSpotY | Hotspot y coordinate (relative to the top left of the image).
  | maskBits | Bits for a mask bitmap.

Availability: only available for the wxGTK, wxMotif ports.

wxPerl Note: In wxPerl use Wx::Cursor->newData(bits, width, height, hotSpotX = -1, hotSpotY = -1, maskBits = 0).

wxCursor::wxCursor | ( | const wxString & | cursorName,
|  | wxBitmapType | type = `wxCURSOR_DEFAULT_TYPE`,
|  | int | hotSpotX = `0`,
|  | int | hotSpotY = `0` |
| ) |  |  |

Constructs a cursor by passing a string resource name or filename.

The arguments hotSpotX and hotSpotY are only used when there's no hotspot info in the resource/image-file to load (e.g. when using `wxBITMAP_TYPE_ICO` under wxMSW or `wxBITMAP_TYPE_XPM` under wxGTK).

Parameters:

  | cursorName | The name of the resource or the image file to load.
  | type | Icon type to load. It defaults to `wxCURSOR_DEFAULT_TYPE`, which is a #define associated to different values on different platforms: under Windows, it defaults to `wxBITMAP_TYPE_CUR_RESOURCE`. Other permitted types under Windows are `wxBITMAP_TYPE_CUR` (to load a cursor from a .cur cursor file) and `wxBITMAP_TYPE_ICO` (to load a cursor from a .ico icon file). under MacOS, it defaults to `wxBITMAP_TYPE_MACCURSOR_RESOURCE`; when specifying a string resource name, first the color cursors 'crsr' and then the black/white cursors 'CURS' in the resource chain are scanned through. Note that resource forks are deprecated on OS X so this is only available for legacy reasons and should not be used in new code. under GTK, it defaults to `wxBITMAP_TYPE_XPM`. See the wxCursor(const wxImage& image) ctor for more info. under X11, it defaults to `wxBITMAP_TYPE_XPM`. under Motif, it defaults to `wxBITMAP_TYPE_XBM`.
  | hotSpotX | Hotspot x coordinate (relative to the top left of the image).
  | hotSpotY | Hotspot y coordinate (relative to the top left of the image).

wxCursor::wxCursor | ( | wxStockCursor | cursorId | ) |

Constructs a cursor using a cursor identifier.

Parameters:

  | cursorId | A stock cursor identifier. See wxStockCursor.

wxCursor::wxCursor | ( | const wxImage & | image | ) |

Constructs a cursor from a wxImage.

If cursor are monochrome on the current platform, colors with the RGB elements all greater than 127 will be foreground, colors less than this background. The mask (if any) will be used to specify the transparent area.

In wxMSW the foreground will be white and the background black. If the cursor is larger than 32x32 it is resized.

In wxGTK, colour cursors and alpha channel are supported (starting from GTK+ 2.2). Otherwise the two most frequent colors will be used for foreground and background. In any case, the cursor will be displayed at the size of the image.

In wxMac, if the cursor is larger than 16x16 it is resized and currently only shown as black/white (mask respected).

wxCursor::wxCursor | ( | const wxCursor & | cursor | ) |

Copy constructor, uses reference counting.

Parameters:

  | cursor | Pointer or reference to a cursor to copy.

virtual wxCursor::~wxCursor | ( |  | ) | `[virtual]`

Destroys the cursor.

See reference-counted object destruction for more info.

A cursor can be reused for more than one window, and does not get destroyed when the window is destroyed. wxWidgets destroys all cursors on application exit, although it is best to clean them up explicitly.

## Member Function Documentation

virtual bool wxCursor::IsOk | ( |  | ) | const`[virtual]`

Returns true if cursor data is present.

wxCursor& wxCursor::operator= | ( | const wxCursor & | cursor | ) |

Assignment operator, using reference counting.

|  | [ top ]